#include <windows.h>
#include <cstdio>

using namespace std;

struct stDirecciones {
    bool arriba;
    bool abajo;
    bool izquierda;
    bool derecha;
    bool escape;
};

DWORD WINAPI LeeTeclado( void* par) {
    stDirecciones *dirs = (stDirecciones*)par;
//    COORD dwPos = {0,0};

    do {
//        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
//        printf("UP     %08x\n", (unsigned short)GetAsyncKeyState(VK_UP));
//        printf("DOWN   %08x\n", GetAsyncKeyState(VK_DOWN));
//        printf("LEFT   %08x\n", GetAsyncKeyState(VK_LEFT));
//        printf("RIGHT  %08x\n", GetAsyncKeyState(VK_RIGHT));
//        printf("ESCAPE %08x\n", GetAsyncKeyState(VK_ESCAPE));
        dirs->arriba    = GetAsyncKeyState(VK_UP) & 0x8000; // GetAsyncKeyState(VK_UP);
        dirs->abajo     = GetAsyncKeyState(VK_DOWN) & 0x8000; // GetAsyncKeyState(VK_DOWN);
        dirs->izquierda = GetAsyncKeyState(VK_LEFT) & 0x8000; // GetAsyncKeyState(VK_LEFT);
        dirs->derecha   = GetAsyncKeyState(VK_RIGHT) & 0x8000; // GetAsyncKeyState(VK_RIGHT);
        dirs->escape    = GetAsyncKeyState(VK_ESCAPE) & 0x8000; // GetAsyncKeyState(VK_ESCAPE);
    } while (!dirs->escape);

    return 0;
}

int main() {

    HANDLE hTeclado;
    stDirecciones dirs;
    COORD dwPos = {0,0};

    hTeclado = CreateThread( 0, 0, LeeTeclado, (void*)&dirs, 0, 0);

    do {
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
        printf(" ");
        if(dirs.arriba && dwPos.Y > 0) dwPos.Y--;
        if(dirs.abajo  && dwPos.Y < 25) dwPos.Y++;
        if(dirs.izquierda && dwPos.X > 0) dwPos.X--;
        if(dirs.derecha   && dwPos.X < 79) dwPos.X++;
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
        printf("*");
        Sleep(20);
    } while(!dirs.escape);

    CloseHandle(hTeclado);
    return 0;
}

